-- =====================================
-- Author      : Txty
-- Create Date : 9/23/2014 12:27:36 AM
-- =====================================
local ADDON_NAME, namespace = ...
-------------------------------------
local DEFAULT_SETTINGS = {
	char = { SetPointx = 0, SetPointy = 0, point = "CENTER", relativePoint = "CENTER", lock = false,
	size = 1.0, color = "Grey", playerName = "", enabled = true, name = 529, bg = "ab", 
	chatType = "INSTANCE_CHAT", target = nil, language = 1, col = 1, row = 5, button = nil } 
}
-------------------------------------
BGCallouts = LibStub("AceAddon-3.0"):NewAddon("BGCallouts", "AceConsole-3.0", "AceEvent-3.0" );
-------------------------------------
function BGCallouts:OnInitialize()
-- Called when the addon is loaded
	BGCallouts:Print("Loaded")
	BGCallouts = namespace.init(ADDON_NAME)
--	namespace.config = CreateFrame("Frame","ConfigFrame",UIParent)
	namespace.config = CreateFrame("Frame",nil,UIParent)
	namespace.config.db = LibStub('AceDB-3.0'):New("BGCalloutsDB", DEFAULT_SETTINGS)
end
-----------------------------------
local function initBG()
	namespace.SetChatType("INSTANCE_CHAT")
--	DEFAULT_CHAT_FRAME:AddMessage("|cff00ff96BGCallouts: |cff00ccffid Faction is " .. UnitFactionGroup('player'))
	if UnitFactionGroup('player') == "Alliance" then
		namespace.config.db.char.language = 7	-- Alliance Common
		DEFAULT_CHAT_FRAME:AddMessage("|cff00ff96BGCallouts: |cff00ccffYou speak now Common")
	else
		namespace.config.db.char.language = 1	-- Horde Orcish
		DEFAULT_CHAT_FRAME:AddMessage("|cff00ff96BGCallouts: |cff00ccffYou speak now Orchish")
	end
	namespace.myLock(BGCallouts)
end
-----------------------------------
local function func(iid)
--	DEFAULT_CHAT_FRAME:AddMessage("|cff00ff96BGCallouts: |cff00ccffid " .. iid)
	if namespace.config.db.char.enabled and namespace.iidBG[iid] then
		namespace.setBattleground(iid)
		initBG()
		BGCallouts:Show(true)
	else
		BGCallouts:Hide(true)
	end
return end
-------------------------------------
local function enableFrame()
	namespace.config.db.char.enabled = true
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ff96BGCallouts: |cff00ccff" .. "Addon is enabled.")
end
-------------------------------------
-- Slash commands
SLASH_BGC1 = "/BGC" or "/bgc"
SlashCmdList["BGC"] = function (msg)
	if (msg=="show") then
		BGCallouts:Show(true)
		enableFrame()
	else
		DEFAULT_CHAT_FRAME:AddMessage("|cff00ff96BGCallouts: |cff00ccff" .. "Only works with '/bgc show'.")
	end
end
-------------------------------------
function BGCallouts:OnEnable()	
	if namespace.config.db.char then
		local z = "UIParent"
		local p, r = namespace.config.db.char.point, namespace.config.db.char.relativePoint
		local x, y = namespace.config.db.char.setPointx, namespace.config.db.char.setPointy
		BGCallouts:SetPoint(p,z,r,x,y)
		BGCallouts:SetSize(namespace.config.db.char.col * 40+18, namespace.config.db.char.row * 40+18)
		BGCallouts:SetScale(namespace.config.db.char.size)
		namespace.config.db.char.playerName = GetUnitName('player', true)
		namespace.classColor(namespace.config.db.char.color)
		namespace.setBattleground(namespace.config.db.char.name)
		initBG()
	end
	enableFrame()
	BGCallouts:Hide(true)
	self:RegisterEvent("ZONE_CHANGED_NEW_AREA")
	func(select(8,GetInstanceInfo()))
end
-------------------------------------
function BGCallouts:OnDisable()
		-- Called when the addon is disabled
end
-------------------------------------
function BGCallouts:ZONE_CHANGED_NEW_AREA()
	func(select(8,GetInstanceInfo()))
end
-- END ------------------------------
